从VC6.0平台级到VS2008平台(之一)

VC6.0平台级到VS2008平台

最近在在把一些程序从VC6迁移到VS2008,由此而关注到一些这方面的知识,找了一些资料,根据自己遇到的一些情况,结合在一起,整理出来这篇文章,希望对以后有这方面工作的人多一些参考,如果大家还有可很享的可以跟贴。。。。

1、关于 #define WINVER

提到这个问题是因为,这里涉及到Winodws版本的定义。关于版本定义的关键无外乎为程序头文件中对于#define WINVER #define _WIN32_WINNT 的使用,具体为:

#define WINVER 0xXXXX
#define _WIN32_WINNT 0xXXXX

该定义一般用于标示程序对运行环境的要求,另外在某些头文件中也有这样的宏定义。如果版本匹配的话就会在编译的时候将这些内容编译,否则就不编译。

定义正确的Windows版本,不仅关系到程序的正确编译,同时也关系到程序的正确运行;在升级的过程中,我就碰到了程序编译正确但运行出错的问题。

版本的定义关系到被编译到程序中的内容,这里主要是指系统提供的功能代码。Windows各个版本的功能虽然大差不差,但特定于某个系统功能还是存在的,于是关系到这些功能的API代码也就有所不一样。当我们在程序中定义了错误的系统版本,被编译进程序的内容便可能包含当前系统不支持的代码片段,这样的程序即使可能正确编译通过,但在运行的时候,由于在当前系统中找不到相应的内容资源,从而发生错误。这一点熟悉动态链接库(DLL)的人都很清楚,其实该问题就是和系统动态链接库有关。
   
考虑到我迁移程序的时候,是直接利用VS2008VC6程序转化的方式,然后按VS2008新建项目的StdAfx.h文件内容更新了原来的StdAfx.h头文件,并添加了VS2008项目才有的targerver.h头文件。(工程转换时,没有targerver.h为我们生成,默认的WINVER = 0x0600 的系统环境(这里指明了系统为Vista),所以要改变就要自己手动添加targerver.h)
根据targetver.h头文件里的下列定义:

#ifndef WINVER                  // 指定要求的最低平台是 Windows Vista
#define WINVER 0x0600           // 将此值更改为相应的值,以适用于 Windows 的其他版本。
#endif
 #ifndef _WIN32_WINNT            // 指定要求的最低平台是 Windows Vista
#define _WIN32_WINNT 0x0600     // 将此值更改为相应的值,以适用于 Windows 的其他版本。
#endif

PS0×0500 表示Windows 20000×0501Windows XP0×0502Windows Server 20030×0600 Windows Vista
2、关于DX8SDK使用中link时出现的libci.lib无法找到的问题

    最近开发过程中碰到了用DX8 SDK编译项目时,link的时候,无法打开libci.lib的问题.

    LINK:fatal error  LNK1104:无法打开文件:libci.lib"

     解决办法如下:

    选择工程的属性,linker选项中选择Command line ,增加下面一行:

      /nodefaultlib:libci 

   原因:

出现在Vc9,可能没有选择安装旧的iostream”.导致这个问题.在我看来,还是微软的问题.

©️2020 CSDN 皮肤主题: 大白 设计师:CSDN官方博客 返回首页